/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/**
@file
@brief
  ConvFileDll NāAt@C̕ϊsR}hCc[łB
*/

#include "stdafx.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <vector>
#include <string>
using namespace std ;

#include "CConvFileDll.h"
#include "CaByteBuffer_vector.h"


const char g_szUsage[]=
"ConvFileExec ConvFileDllFilename LeftFilename RightFilename" "\n"
"	w ConvFileDll gāÃt@CẼt@Cɕϊ܂B" "\n"
"@param ConvFileDllFilename" "\n"
"	ConvFileDll ̃t@Cw肵ĂB" "\n"
"@param LeftFilename" "\n"
"	(ϊ)̃t@Cw肵ĂB" "\n"
"@param RightFilename" "\n"
"	̃R}h́Aϊʂ̃t@Cŕۑ܂B" "\n"
;

/**
@return
	-	0 ;	//	
	-	1 ;	//	tH[}bg܂B
	-	101 ;	//	DLL݂܂B
	-	11 ;	//	LeftFile ǂݍ߂܂B
	-	21 ;	//	RightFile ɏ߂܂B
*/
int main(int argc, char* argv[])
{
	int iRv = 0 ;
	string	strError ;
	// --------------------------------
	//	̉
	// --------------------------------
	string	strDllFilename ;
	string	strLeftFilename ;
	string	strRightFilename ;
	if ( iRv >= 0 )
	{
		if ( argc != 4 )
		{
			strError = g_szUsage ;
			iRv = -201 ;	//	p[^słB
			fprintf( stderr , g_szUsage ) ;
			return ( iRv ) ;
		}
		else
		{
			strDllFilename = argv[1] ;
			strLeftFilename = argv[2] ;
			strRightFilename = argv[3] ;
		}
	}
	// --------------------------------
	//	DLL̃[h
	// --------------------------------
	CConvFileDll	aCConvFileDll( strDllFilename ) ;
	if ( iRv >= 0 )
	{
		int iResult = aCConvFileDll.validate() ;
		if ( iResult < 0 )
		{
			strError = "DLL݂܂B" ;
			iRv = -101 ;	//	DLL݂܂B
		}
	}
	// --------------------------------
	//	LeftFile ̓ǂݍ
	// --------------------------------
	vector<char>	binLeftFile ;
	if ( iRv >= 0 )
	{
		FILE*	pFile = fopen( strLeftFilename.c_str() , "rb" ) ;
		if ( pFile == NULL )
		{
			strError = "LeftFile ǂݍ߂܂B" ;
			iRv = -11 ;	//	LeftFile ǂݍ߂܂B
		}
		else
		{
			struct	stat	aStat ;
			if ( stat( strLeftFilename.c_str() , &aStat ) == 0 )
			{
				binLeftFile.reserve( aStat.st_size ) ;
			}
			int iChar ;
			while( ( iChar = fgetc( pFile ) ) != EOF )
			{
				binLeftFile.push_back( iChar ) ;
			}
			fclose( pFile ) ;
		}
	}
	// --------------------------------
	//	LeftFile ̃tH[}bǧ
	// --------------------------------
	if ( iRv >= 0 )
	{
		CaByteBuffer_vector< vector<char> >	aBytebufferLeftFile( &binLeftFile ) ;
		int iResult = aCConvFileDll.getIfConvFile()->isLeftFormat( &aBytebufferLeftFile ) ;
		if ( iResult < 0 )
		{
			strError = "tH[}bg܂B" ;
			iRv = -1 ;	//	tH[}bg܂B
		}
	}
	// --------------------------------
	//	LeftFileRightFileɕϊ
	// --------------------------------
	vector<char>	binRightFile ;
	if ( iRv >= 0 )
	{
		CaByteBuffer_vector< vector<char> >	aBytebufferLeftFile( &binLeftFile ) ;
		CaByteBuffer_vector< vector<char> >	aBytebufferRightFile( &binRightFile ) ;
		int iResult = aCConvFileDll.getIfConvFile()->LeftToRight( 
			&aBytebufferLeftFile , 
			&aBytebufferRightFile , 
			NULL ) ;
		if ( iResult < 0 )
		{
			strError = "tH[}bg܂B" ;
			iRv = -1 ;	//	tH[}bg܂B
		}
	}
	// --------------------------------
	//	RightFile
	// --------------------------------
	if ( iRv >= 0 )
	{
		FILE* pFile = fopen( strRightFilename.c_str() , "wb" ) ;
		if ( pFile == NULL )
		{
			iRv = -21 ;	//	RightFile ɏ߂܂B
		}
		else
		{
			size_t	idxRightFile ;
			for ( idxRightFile = 0 ; 
				iRv >= 0 && idxRightFile < binRightFile.size() ;
				idxRightFile ++ )
			{
				if ( fputc( binRightFile[idxRightFile] , pFile ) == EOF )
				{
					strError = "RightFile ɏ߂܂B" ;
					iRv = -21 ;	//	RightFile ɏ߂܂B
				}
			}
			if ( fclose( pFile ) != 0 )
			{
				strError = "RightFile ɏ߂܂B" ;
				iRv = -21 ;	//	RightFile ɏ߂܂B
			}
		}
	}
	// --------------------------------
	//	RightFile
	// --------------------------------
	if ( iRv < 0 )
	{
		if ( strError.empty() )
		{
			fprintf( stderr , "Error %d\n" , iRv ) ;
		}
		else
		{
			fprintf( stderr , "%s\n" , strError.c_str() ) ;
		}
	}
	return -iRv;
}
