/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdText.cpp
// ****************************************************************
*/
#include "stdafx.h"

#include "./CDcdText.h"
#include "./CConverter_WinGdi.h"
#include "./CdDrawTextFormat2.h"
using namespace std ;
// ****************************************************************
//	CDcdText
// ****************************************************************
CDcdText::CDcdText( 
		const tstring&			strText,
		const CdDrawTextProp&	aCdDrawTextProp = CdDrawTextProp() ,
		const tstring&			strExtent ,
		int						iLinesExtent
	) :
	m_strText( strText ) ,
	m_CdDrawTextProp( aCdDrawTextProp ) ,
	m_strExtent( strExtent ) ,
	m_iLinesExtent( iLinesExtent ) 
{
	if ( m_CdDrawTextProp.getCdFontProp().getPointTextHeight() == 0 && 
		m_CdDrawTextProp.getCdFontProp().getLogicalunitTextHeight() == 0 && 
		m_CdDrawTextProp.getCdFontProp().getLogicalunitCellHeight() == 0 ){
		m_CdDrawTextProp.setCdFontProp( 
			CConverter_WinGdi().CdFontPropOf( DEFAULT_GUI_FONT ) ) ;
	}
}

	
CDcdText::CDcdText() :
	m_iLinesExtent( 1 ) 
{
}
	
CDcdText::~CDcdText() 
{
}
	
// ********************************
//	IfDcDraw
// ********************************
bool CDcdText::DcDraw( IfDcdTarget* pIfDcdTarget ) 
{
	int		iRv = 0 ;
	bool	bRv = false ;
	
	// --------------------------------
	//	tHg̐
	// --------------------------------

	Ou<CGdiHFontHolder> pFontHolder ;

	if ( iRv >= 0 && pFontHolder == NULL ){
		pFontHolder = pIfDcdTarget->createGdiHFontHolder( m_CdDrawTextProp.getCdFontProp() ) ;

		if ( pFontHolder == NULL ){
			iRv = -1 ;	//	tHg̍쐬Ɏs܂B
		}
	}
	// --------------------------------
	bool	bSelectTool = false ;
	COLORREF	colorrefLTextSid = 0xffffffff;
	COLORREF	colorrefLBackSid = 0xffffffff;
	int			iLBkModeSid = -1 ;
	HFONT		hFontSid = NULL ;
	if ( iRv >= 0 ){
		bSelectTool = true ;
		hFontSid = (HFONT)SelectObject( pIfDcdTarget->getHdc() , pFontHolder->getHFont() ) ;

		CConverter_WinGdi	aConv ;
		colorrefLTextSid = SetTextColor( 
			pIfDcdTarget->getHdc() , 
			aConv.COLORREFOf( m_CdDrawTextProp.getTextColor() ) ) ;
		colorrefLBackSid = SetBkColor( 
			pIfDcdTarget->getHdc() , 	
			aConv.COLORREFOf( m_CdDrawTextProp.getBackColor() ) ) ;
		int	iLBkMode = TRANSPARENT ;
		if ( m_CdDrawTextProp.getIsOpaque() ){
			iLBkMode = OPAQUE ;
		}
		iLBkModeSid = SetBkMode( pIfDcdTarget->getHdc() , iLBkMode ) ;
	}
	
	if ( iRv >= 0 ){
		RECT	aRect ;
		aRect.left = pIfDcdTarget->getZone().getX().getPos() ;
		aRect.right = pIfDcdTarget->getZone().getX().getEndPos() ;
		aRect.top = pIfDcdTarget->getZone().getY().getPos() ;
		aRect.bottom = pIfDcdTarget->getZone().getY().getEndPos() ;
		DrawText( pIfDcdTarget->getHdc() , m_strText.c_str() , -1 
				, &aRect , m_CdDrawTextProp.getCdDrawTextFormat() ) ;
		bRv = true ;
	}
	//--------------------------------
	if ( bSelectTool ){
		SetBkMode( pIfDcdTarget->getHdc() , iLBkModeSid  ) ;
		iLBkModeSid = -1 ;
		SetTextColor( pIfDcdTarget->getHdc() , colorrefLTextSid ) ;
		colorrefLTextSid = 0xffffffff ;
		SetBkColor( pIfDcdTarget->getHdc() , colorrefLBackSid ) ;
		colorrefLBackSid = 0xffffffff;
		SelectObject( pIfDcdTarget->getHdc() , hFontSid ) ;
		hFontSid = NULL ;
	}

	return ( bRv ) ;
}
	
bool CDcdText::getItemSize( IfDcdTarget* pIfDcdTarget , 
							CdDcdSizeXy* pCdDcdSizeXy ) 
{
	int		iRv = 0 ;
	bool	bRv = false ;
	// --------------------------------
	//	tHg̐
	// --------------------------------
	Ou<CGdiHFontHolder> pFontHolder ;
	if ( iRv >= 0 ){
		pFontHolder = pIfDcdTarget->createGdiHFontHolder( m_CdDrawTextProp.getCdFontProp() ) ;
		if ( pFontHolder == NULL ){
			iRv = -1 ;	//	tHg̍쐬Ɏs܂B
		}
	}
	//--------------------------------
	//	GDIIuWFNg̑I
	//--------------------------------
	bool	bSelectTool = false ;
	COLORREF	colorrefLTextSid = 0xffffffff;
	COLORREF	colorrefLBackSid = 0xffffffff;
	HFONT		hFontSid = NULL ;
	if ( iRv >= 0 )
	{
		bSelectTool = true ;
		hFontSid = (HFONT)SelectObject( pIfDcdTarget->getHdc() , pFontHolder->getHFont() ) ;

		CConverter_WinGdi	aConv ;
		colorrefLTextSid = SetTextColor( 
			pIfDcdTarget->getHdc() , 
			aConv.COLORREFOf( m_CdDrawTextProp.getTextColor() ) ) ;
		colorrefLBackSid = SetBkColor( 
			pIfDcdTarget->getHdc() , 	
			aConv.COLORREFOf( m_CdDrawTextProp.getBackColor() ) ) ;
	}
	//--------------------------------
	
	string strExtent ;
	if ( iRv >= 0 ){
		strExtent = m_strExtent ;
		if ( strExtent.empty() ){
			strExtent = m_strText ;
		}
	}
	//strExtent = eLXǧ̕vZ̊ƂȂ镶B

	if ( iRv >= 0 ){
		//--------------------------------
		//	eLXg̉̌vZ
		//--------------------------------
		{
			tstring	strLs ;
			strLs += strExtent ;
			CdDrawTextFormat2	aFlag( m_CdDrawTextProp.getCdDrawTextFormat() ) ;
			aFlag.setCalcrect( CdDrawTextFormat2::CALCRECT )
				.setVertical( CdDrawTextFormat::V_SINGLELINT_TOP )
				.setEllipses( CdDrawTextFormat::NOELLIPSIS )  ;
			//aFlag = w̃tH[}bgPsE
			//	ȗLȂETCYvZɏC܂

			RECT	aRect ;
			memset( &aRect , 0 , sizeof(aRect) ) ;
			DrawText(  pIfDcdTarget->getHdc() , 
					strLs.c_str() , -1 , &aRect , aFlag ) ;
				//LRect.right = eLXg m_strExtent ̕
			pCdDcdSizeXy->setX( aRect.right - aRect.left ) ;
		}
		//--------------------------------
		//	eLXg̍̌vZ
		//--------------------------------
		{
			tstring	strLs ;
			int	iLi ;
			for ( iLi = 0 ; iLi < m_iLinesExtent ; iLi ++ ){
				if ( iLi > 0 ){
					strLs += TEXT( '\n' ) ;
				}
				strLs += strExtent.c_str() ;
			}
				//strLs = m_strExtentw̍scɕׂ
			
			CdDrawTextFormat2	aFlag( m_CdDrawTextProp.getCdDrawTextFormat() ) ;
			aFlag.setCalcrect( CdDrawTextFormat2::CALCRECT )
				.setVertical( CdDrawTextFormat::V_MULTILINE )
				.setEllipses( CdDrawTextFormat::NOELLIPSIS )  ;
			//aFlag = w̃tH[}bg𕡐sE
			//	ȗLȂETCYvZɏC܂

			RECT	aRect ;
			memset( &aRect , 0 , sizeof(aRect) ) ;
			DrawText( pIfDcdTarget->getHdc() , 
				strLs.c_str() , -1 , &aRect , aFlag ) ;
			//LRect.bottom = eLXg m_strExtent ̍
			
			pCdDcdSizeXy->setY( aRect.bottom - aRect.top ) ;
		}		
	}
	//--------------------------------
	if ( bSelectTool ){
		SetTextColor( pIfDcdTarget->getHdc() , colorrefLTextSid ) ;
		colorrefLTextSid = 0xffffffff ;
		SetBkColor( pIfDcdTarget->getHdc() , colorrefLBackSid ) ;
		colorrefLBackSid = 0xffffffff;
		SelectObject( pIfDcdTarget->getHdc() , hFontSid ) ;
		hFontSid = NULL ;
	}
	return ( iRv >= 0 ) ;

}

