/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CDedCommentView.cpp : Cve[V t@C
// $Id: CDedCommentView.cpp 295 2016-06-11 05:14:13Z okm $

#include "stdafx.h"

#include "NsOu/OuNew.h"
#include "NsOu/dynamic_castOu.h"
#include "str/strLf.h"
#include "str/strToInt.h"
#include "LogMsg\LogMsg.h"
#include "DcDraw\CConverter_WinGdi.h"
#include "DcDrawMfc/CDcdTargetMfcPrintInfo.h"
#include "DcDraw/CaDcdTargetItemPosition.h"
#include "DcDraw/print/CaDcdTargetZoomDisplay.h"

#include "..\DiagramEdit.h"
#include "..\CRfEditCmdHolder.h"
#include "..\DedRosenFileData\EditCmd\EditCmd.h"
#include "..\Print\CconvCdPrintPageProp.h"
#include "CDedCommentView.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewComment{

using namespace std ;
/////////////////////////////////////////////////////////////////////////////
// CDedCommentView

void CDedCommentView::OnUpdate_All() 
{

	LogMsg( "CDedCommentView::OnUpdate_All() View̍XV" ) ;

	CDiagramEditDoc* pRootDoc = getCDiagramEditDoc() ;

	//	tHgύXĂAtHgݒ
	CdFontProp	aCdFontProp = pRootDoc->getCDedRosenFileData()->getCdDedDispProp().getViewCommentFont() ;
	if ( m_CdFontProp != aCdFontProp ){
		if ( m_CFont.GetSafeHandle() != NULL ){
			m_CFont.DeleteObject() ;
		}

		CDC* pDc = GetEditCtrl().GetDC() ;
		CConverter_WinGdi	aConv ;
		m_CFont.CreateFontIndirect( &aConv.LOGFONTOf( aCdFontProp , pDc->GetSafeHdc() ) ) ;
		
		GetEditCtrl().SetFont( &m_CFont ) ;
		// --------------------------------
		if ( pDc != NULL ){
			GetEditCtrl().ReleaseDC( pDc ) ;
			pDc = NULL ;
		}
		m_CdFontProp = aCdFontProp ;
	}
	
	//	eLXgXV	
	string strLs = pRootDoc->getCDedRosenFileData()->getCentDedRosen()->getComment() ;
	{
		int iLineNum = GetEditCtrl().GetFirstVisibleLine() ;
		int iStartChar , iEndChar ;
		GetEditCtrl().GetSel( iStartChar , iEndChar ) ;
		GetEditCtrl().SetWindowText( strCrlfOf( strLs ).c_str() ) ;
		if ( iStartChar > GetEditCtrl().GetWindowTextLength() ){
			iStartChar = GetEditCtrl().GetWindowTextLength() ;
		}
		if ( iEndChar > GetEditCtrl().GetWindowTextLength() ){
			iEndChar = GetEditCtrl().GetWindowTextLength() ;
		}
		GetEditCtrl().LineScroll( iLineNum ) ;
		GetEditCtrl().SetSel( iStartChar , iStartChar , FALSE ) ;
	}

	// --------------------------------
	m_bUpdate_All_Requested = false ;

	LogMsg( "CDedCommentView::OnUpdate_All()=" ) ;

}

void CDedCommentView::OnUpdate_Comment( Ou<CRfEditCmd_Comment> pCommand )
{
	CView *pView = getCDiagramEditApp()->getCMainFrame()->
		getMDIChildActiveView() ;
	
	if ( this != pView )
	{
		LogMsg( "CDedCommentView::OnUpdate_Comment() "
			"̃r[ɂXVthis ɔf܂B" ) ;

		int iLineNum = GetEditCtrl().GetFirstVisibleLine() ;
		int iStartChar , iEndChar ;
		GetEditCtrl().GetSel( iStartChar , iEndChar ) ;
		GetEditCtrl().SetWindowText( strCrlfOf( pCommand->getComment() ).c_str() ) ;
		if ( iStartChar > GetEditCtrl().GetWindowTextLength() ){
			iStartChar = GetEditCtrl().GetWindowTextLength() ;
		}
		if ( iEndChar > GetEditCtrl().GetWindowTextLength() ){
			iEndChar = GetEditCtrl().GetWindowTextLength() ;
		}
		GetEditCtrl().SetSel( iStartChar , iStartChar ) ;
		GetEditCtrl().LineScroll( iLineNum ) ;

	}
	else
	{
		LogMsg( "CDedCommentView::OnUpdate_Comment() "
			"thisɂXVȂ̂ŁÃr[ɂ͔f܂B" ) ;
	}

}

IMPLEMENT_DYNCREATE(CDedCommentView, CEditView)

CDedCommentView::CDedCommentView(): 
	m_bUpdate_All_Requested( false ) ,
	m_bIsChanged( false )
{
}

CDedCommentView::~CDedCommentView()
{
}


BEGIN_MESSAGE_MAP(CDedCommentView, CDedCommentView::super)
	//{{AFX_MSG_MAP(CDedCommentView)
	ON_CONTROL_REFLECT(EN_CHANGE, OnChange)
	ON_WM_DESTROY()
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, OnFilePrintPreview)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDedCommentView `

void CDedCommentView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: ̈ʒuɕ`p̃R[hǉĂ
}

/////////////////////////////////////////////////////////////////////////////
// CDedCommentView ff

#ifdef _DEBUG
void CDedCommentView::AssertValid() const
{
	super::AssertValid();
}

void CDedCommentView::Dump(CDumpContext& dc) const
{
	super::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDedCommentView bZ[W nh

void CDedCommentView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if ( lHint ==  LHINT_SUBVIEW_TO_ROOTDOC  )
	{
		//[Attention]
		//	(lHint== LHINT_SUBVIEW_TO_ROOTDOC )̏ꍇ́A
		//	r[̓e[gDocɔf
		//	B
		if ( m_bIsChanged )
		{
			// --------------------------------
			//	R}h̐Es
			// --------------------------------
			CString	strLs ;
			GetEditCtrl().GetWindowText( strLs ) ;
			OuNew<CRfEditCmd> pCmd( 
				new CRfEditCmd_Comment( strLfOf( (LPCTSTR)strLs ) ) ) ;
			int  iResult = getCDiagramEditDoc()->executeEditCmd( pCmd ) ;
			ASSERT( iResult >= 0 ) ;
			
			// --------------------------------
			m_bIsChanged = false ;
		}
	}	else	{
		//[Attention]
		//	(lHint!= LHINT_SUBVIEW_TO_ROOTDOC )̏ꍇ́A
		//	[gDoc̓er[
		//	fĂB

		//pHint= 
		//	pHint CRfEditCmdHolder IuWFNgȂA
		//	ΉҏWR}h CRfEditCmd ێĂ܂B
		//	̏ꍇAthis  CRfEditCmd ̓eɍœK
		//	XVs܂B
		//	NULLȂASXVvĂ܂B
		if ( m_bUpdate_All_Requested )
		{
			//	SXVۗĂꍇ́A
			//	̌̓R}hɂœKꂽP̂̂ȂXVvɑ΂ĂASXVs܂B
			pHint = NULL ;
		}

		Ou<CRfEditCmd> pCmd ;
		if ( pHint != NULL && pHint->IsKindOf( RUNTIME_CLASS( CRfEditCmdHolder ) ) ){
			CRfEditCmdHolder* pCHolder = (CRfEditCmdHolder*)pHint ;
			pCmd = pCHolder->getCmd() ;
		}
		if ( pCmd != NULL ){
			if ( 
				dynamic_castOu<CRfEditCmd_Comment>( pCmd ) 
			) {
				//	RgύXꂽAݒ肵܂B
				//	AÃr[ANeBuȏꍇ́A̍XV͍s܂B
				Ou<CRfEditCmd_Comment>	pCommand = 
					dynamic_castOu<CRfEditCmd_Comment>( pCmd ) ;
				OnUpdate_Comment( pCommand ) ;
			}	else if ( 
				dynamic_castOu<CRfEditCmd_Dia>( pCmd ) ||
				dynamic_castOu<CRfEditCmd_DiaProp>( pCmd ) ||
				dynamic_castOu<CRfEditCmd_Eki>( pCmd ) ||
				dynamic_castOu<CRfEditCmd_Ressya>( pCmd ) ||
				dynamic_castOu<CRfEditCmd_Ressyasyubetsu>( pCmd ) ||
				dynamic_castOu<CRfEditCmd_RessyasyubetsuSwap>( pCmd ) 
			){
				//	̃r[́A
				//		_C̕ύX
				//		_C̃vpeB̕ύX
				//		w̕ύX
				//		Ԃ̕ύX
				//		Ԃ̒ʉ
				//		Ԏʂ̕ύX
				//		Ԏʂ̓
				//	̏ꍇ́AXVs܂B
			}
			else
			{
				//	SXV
				//CRfEditCmd_DedRosenFileDataProp
				//	tHgXVꍇ܂̂ŁASXVKvł
				//CRfEditCmd_Rosen
				//CRfEditCmd_RosenFileData
				//	CentDedRosen ܂IuWFNg̒uB
				pHint = NULL ;
			}
		}
		
		//	œKꂽXVȂꍇ́A
		//	SXVv
		if ( pHint == NULL ){
			if ( getCDiagramEditApp()->getCMainFrame()->getMDIChildActiveView() != this ){
				//	̃r[AXVv܂B
				//	r[̍XV́Ãr[ANeBuɂȂ܂
				//	ۗ܂B
				LogMsg( "CDedCommentView::OnUpdate() View̍XVۗ" ) ;
				m_bUpdate_All_Requested = true ;
				return ;
			}
			//	r[̑SXV
			OnUpdate_All() ;
		}
	}
}

void CDedCommentView::OnChange() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CEditView::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	getCDiagramEditDoc()->SetModifiedFlag( TRUE ) ;
	m_bIsChanged = true ;
	
}

void CDedCommentView::OnFilePrintPreview() 
{
	//	vr[Lɂ܂B
	super::OnFilePrintPreview() ;
}

void CDedCommentView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	if ( !bActivate ){
		//[Attention]
		//	̃r[ANeBuɂȂƂɂ́A
		//	OnUpdate(lHint=LHINT_SUBVIEW_TO_ROOTDOC)ĂяoāA
		//	̃r[̓e
		//	[gDocɔfŁAɃ[gDoc̓e
		//	ׂẴTuDoc/ViewɔfĂB


		// --------------------------------
		//	wHxhLg̍XV
		// --------------------------------
		OnUpdate( this , LHINT_SUBVIEW_TO_ROOTDOC , NULL ) ;


	}
	if ( m_bUpdate_All_Requested && bActivate ){
		//	r[̍XVۗĂԂŁA
		//	r[ANeBuɂȂƂ́A
		//	r[̍XVs킹܂B
		OnUpdate_All() ;
	}
	
	
	super::OnActivateView(bActivate, pActivateView, pDeactiveView);
}

void CDedCommentView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo) 
{
	if ( m_bUpdate_All_Requested ){
		//	r[̍XVۗĂꍇ́A
		//	r[̍XVs킹܂B
		OnUpdate_All() ;
	}
	
	super::OnBeginPrinting(pDC, pInfo);
}

void CDedCommentView::OnDestroy() 
{
	CFont	aCFont ;
	aCFont.CreateStockObject( SYSTEM_FONT ) ;
	GetEditCtrl().SetFont( &aCFont ) ;

	super::OnDestroy();
}


BOOL CDedCommentView::PreCreateWindow(CREATESTRUCT& cs) 
{
	
	BOOL bRv = super::PreCreateWindow(cs);

	//	XN[o[폜A
	//	eLXgE[Ő܂Ԃ悤ɕύX
	if ( bRv ){
		cs.style &=~( WS_HSCROLL ) ;
		cs.style &=~( ES_AUTOHSCROLL ) ;
	}
	return ( bRv ) ;
}


CdDrawTextProp	CDedCommentView::getCdDrawTextPropStandard()
{ 
	const CDedRosenFileData* pCDedRosenFileData = 
		getCDiagramEditDoc()->getCDedRosenFileData() ;
	CdDedDispProp aCdDedDispProp = pCDedRosenFileData->getCdDedDispProp() ;

	return CdDrawTextProp( 
		m_CdFontProp ,
		CdColorProp( 0 , 0 , 0 ) ) ;
}



void CDedCommentView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	super::OnPrint( pDC , pInfo ) ;
	return ;


	//	ȉ̃R[h́Ay[Wԍ
	//	\悤Ƃ̂łA
	//	ASSERTɂȂĂ܂܂B
	//	̂߁Aʂ͓삳܂B
/*
	//attention
	//	̃NX́Ay[WƂ̊Jnʒu
	//	LbVĂ܂iCEditView::m_aPageStartjB
	//	Ƃ낪A}bv[h
	//	ύXĂꍇAvr[\ɃEChETCY
	//	ύXƁALbVƎۂ̕\H
	//	܂AASSERTɂȂĂ܂܂B
	//	ȉ̂R֐s邱ƂɂALbVNAł
	//	Ƃ܂B
	//	
	//	OnPrepareDC  ̊֐Ăяo܂B
	//	OnPrepareDCĂяoꂽꍇ́A
	//	̋Ԃ̎sׂ͔łB
	//	b ́AOnPrepareDCsł邱ƂtOłB
	static bool b = false ;
	if ( !b ){
		b = true ;

		//attention
		//	ȉsƁAv^DC܂B
		//	R͕słB
		//
		//	CPrintInfo	aCPrintInfo = *pInfo ;
		
		super::OnEndPrinting( pDC, pInfo ) ;
		super::OnBeginPrinting( pDC, pInfo ) ;
		super::OnPrepareDC( pDC, pInfo ) ;

		b = false ;

		//attention
		//	ƁAv^DC܂B
		//	R͓łB
		//
		//	*pInfo = aCPrintInfo ;
	}



	LogMsg( "CDedCommentView::OnPrint() " ) ;
	LogMsg( CDcdTargetMfcPrintInfo::stringOf( pInfo ).c_str() ) ;

	// --------------------------------
	//	`ʂ쐬
	// --------------------------------
	CDcdTargetMfcPrintInfo	aCDcdTargetMfcPrintInfo( pDC, pInfo ) ;

	LogMsg( "CDedCommentView::OnPrint()1" ) ;

	// --------------------------------
	//	]̈쐬
	// --------------------------------
	CaDcdTargetItemPosition	aTargetInnerMargin( &aCDcdTargetMfcPrintInfo , 
		CdDcdZoneXy() ) ;
	{
		LogMsg( DeviceCapsToString( 
			aCDcdTargetMfcPrintInfo.getPrinterHdc() ).c_str() ) ;
	
		CconvCdPrintPageProp aCconvCdPrintPageProp ;
		CdDcdZoneXy	zonexyInneraMargin = 
			aCconvCdPrintPageProp.calcZoneInnerMargin( 
				getCDiagramEditApp()->getCdPrintPageProp() , 
				aCDcdTargetMfcPrintInfo.getPrinterHdc() ) ;
		if ( zonexyInneraMargin.getX().getSize() <= 0 ){
			zonexyInneraMargin.setX( 
				aCDcdTargetMfcPrintInfo.getZone().getX() ) ;
		}
		if ( zonexyInneraMargin.getY().getSize() <= 0 ){
			zonexyInneraMargin.setY( 
				aCDcdTargetMfcPrintInfo.getZone().getY() ) ;
		}

		aTargetInnerMargin.setZone( zonexyInneraMargin ) ;

	}

	//aTargetInnerMargin = ]`̈B
	//	Pʂ̓v^̃sNZłB


	LogMsg( "CDedCommentView::OnPrint()2" ) ;

	// --------------------------------
	//	_Wݒ
	// --------------------------------
	CaDcdTargetZoomDisplay	aCaDcdTargetZoomDisplay( 
		&aTargetInnerMargin , 
		aCDcdTargetMfcPrintInfo.getPrinterHdc() ) ;
	//aCaDcdTargetZoomDisplay = ]`̈B
	//	Pʂ́Aʏ̂PsNZɂȂ܂B
	IfDcdTarget*	pTarget =  &aCaDcdTargetZoomDisplay ;
	
	//pTarget = `s̈B
	//	Pʂ́Aʏ̂PsNZɂȂ܂B

	LogMsg( "CDedCommentView::OnPrint()3" ) ;
	// --------------------------------
	//	y[WԍDcDrawIuWFNgi쐬
	// --------------------------------
	
	//memo: LvV͍̈sȂƂɂ܂B
	//	Ou<CDcdText>	pdcdCaption ;
	//	{
	//		const CentDedRosen* pCentDedRosen = 
	//			getCDiagramEditDoc()->getCDedRosenFileData()
	//				->getCentDedRosen() ;
	//			CJikokuhyouDoc* pCJikokuhyouDoc = 
	//				(CJikokuhyouDoc*)GetDocument() ;
	//		
	//			string	strText ;
	//			//	H
	//			if ( !pCentDedRosen->getName().empty() ){
	//				strText += pCentDedRosen->getName() ;
	//				strText += " " ;
	//			}
	//		
	//			pdcdCaption = OuNew<CDcdText>( new CDcdText( 
	//				strText , getCdDrawTextPropStandard() ) ) ;
	//		}

	Ou<CDcdText>	pdcdPage ;
	{
		CdDrawTextProp	aProp = getCdDrawTextPropStandard() ;
		CdDrawTextFormat	aFormat = aProp.getCdDrawTextFormat() ;
		aFormat.setHorizontal( aFormat.H_CENTER ) ;
		aProp.setCdDrawTextFormat( aFormat ) ;
		pdcdPage = OuNew<CDcdText>( new CDcdText( "" ,aProp , "99" ) ) ;
	}
	//pdcdPage = y[WԍDcDrawIuWFNg
	
	// --------------------------------
	//	y[Wԍ̕iE
	//	CEditView eLXg̃CAEg߂	
	// --------------------------------
	
	//memo: LvV͍̈sȂƂɂ܂B
	//	Ou<CaDcdTargetItemPosition>	pTargetCaption ;

	Ou<CaDcdTargetItemPosition>	pTargetEditView ;
	Ou<CaDcdTargetItemPosition>	pTargetPage ;
	{
		CdDcdZoneXy	zoneEditView = pTarget->getZone() ;
		//zoneEditView=]`̈B
		//	y[Wԍ̂A
		//	ŏIIɃGfBbgr[ɋLꂽe
		//	̈łB


		//memo: LvV͍̈sȂƂɂ܂B
		//	pdcdCaption->getItemSize( pTarget , &aSize ) ;
		//	CdDcdZoneXy zoneCaption( zoneEditView.getX() , 
		//		CdDcdZone( zoneEditView.getY().getPos() , aSize.getY() ) ) ;
		//	zoneEditView.setY( CdDcdZone().setBeginEndPos( 
		//		zoneCaption.getY().getEndPos() + aSize.getY() , 
		//		zoneEditView.getY().getEndPos() ) ) ;
		//	//zoneCaption = S̈̏㕔ALvVpɊ蓖ĂĂ܂B
		//	//zoneEditView = S̈悩A㕔̃LvV̈
		//	//	̈łB
		//	
		//	pTargetCaption = OuNew<CaDcdTargetItemPosition>( 
		//		new CaDcdTargetItemPosition( pTarget , zoneCaption ) ) ;

		// --------------------------------
		//	y[Wԍ̗̈ IfDcdTarget
		// --------------------------------
		{
			CdDcdSizeXy	aSize ;
			pdcdPage->getItemSize( pTarget , &aSize ) ;
			CdDcdZoneXy zonePage( zoneEditView.getX() , 
				CdDcdZone( zoneEditView.getY().getEndPos() - aSize.getY() ,
				aSize.getY() ) ) ;
			//zonePage = S̈̉Ay[WpɊ蓖ĂĂ܂B
			pTargetPage = OuNew<CaDcdTargetItemPosition>(
				new CaDcdTargetItemPosition( pTarget , zonePage ) ) ;
			//pTargetPage=y[WpIfDcdTarget

			zoneEditView.setY( CdDcdZone().setBeginEndPos( 
				zoneEditView.getY().getPos() , //zoneCaption.getY().getEndPos() , 
				zonePage.getY().getPos() - aSize.getY()) ) ;
			//zoneEditView = 㕔̃LvVɑāÃy[Ẅ̈łB
		}

		// --------------------------------
		//	Rec̈ IfDcdTarget
		// --------------------------------
		pTargetEditView = OuNew<CaDcdTargetItemPosition>( 
			new CaDcdTargetItemPosition( pTarget , zoneEditView ) ) ;
	}
	// --------------------------------
	//	CEditView̃eLXg`
	// --------------------------------
	int iPage = 0 ;
	{
		CRect	rectDrawSid = pInfo->m_rectDraw ;

		// --------------------------------
		//	v^p̃tHgݒ
		//	i̊֐DC̃}bv[hύXĂ܂B
		//	CEdit ̃ftHg̃tHǵA̕ύXlĂȂ߁A
		//	v^p̃tHgV}bv[h
		//	킹̂ɕύXKv܂j
		// --------------------------------
		Ou<CGdiHFontHolder>	pHFontHolder ;
		CFont	aCFont ;
		CFont*	pFontSid = NULL ;
		{
			pHFontHolder = pTargetEditView->createGdiHFontHolder( getCdDrawTextPropStandard().getCdFontProp() ) ;
			aCFont.Attach( pHFontHolder->getHFont() ) ;
			pFontSid = GetPrinterFont() ;
			SetPrinterFont( &aCFont ) ;
		}
		// --------------------------------
		//	pInfo->m_rectDraw A
		//	y[ẄɏC܂B
		// --------------------------------
		CConverter_WinGdi	aConv ;
		pInfo->m_rectDraw = aConv.RECTOf( pTargetEditView->getZone() ) ;
		// --------------------------------
		//	
		// --------------------------------
		super::OnPrint(pDC, pInfo);
		// --------------------------------
		//	pInfo->m_rectDraw 𕜋A
		// --------------------------------
		pInfo->m_rectDraw = rectDrawSid ;

		// --------------------------------
		//	v^p̃tHg߂
		// --------------------------------
		{
			SetPrinterFont( pFontSid ) ;
			pFontSid = NULL ;
			aCFont.Detach() ;
		}


		// --------------------------------
		iPage = pInfo->m_nCurPage - 1 ;
	}
	//iPage = y[Wԍ(0N_)
	LogMsg( "CDedCommentView::OnPrint()6" ) ;
	// --------------------------------
	//	y[Wԍ̃eLXg쐬
	// --------------------------------
	{
		//y[Wԍ
		{
			string	strPage = OuLib::stringOf( iPage + 1) ;
			pdcdPage->setText( strPage ) ;
		}
	}

	LogMsg( "CDedCommentView::OnPrint()7" ) ;
	// --------------------------------
	//	y[Wԍ`
	// --------------------------------
	{
		//memo: LvV͍̈sȂƂɂ܂B
		//
		//	pdcdCaption->DcDraw( pTargetCaption ) ;

		pdcdPage->DcDraw( pTargetPage ) ;
	}
*/
}
} //namespace ViewComment
